// Agent zero_intelligence_asset_manager in project ethicalHFT

{ include("$jacamoJar/templates/common-cartago.asl") }
{ include("$jacamoJar/templates/common-moise.asl") }
{ include("inc/situation_awareness.asl")}

/* Initial beliefs and rules */

countdown(5).
coin(1).

trade(X):- buy(X).
trade(X):- sell(X).

/* Initial goals */

!start.
!subscribe.

/* Plans */

+!start : true 
	<-	.my_name(N);
		.concat("art_",N,ArtN);	
		makeArtifact(ArtN, "agentLink.AgentLinkArtifact", [N], ArtId);
		focus(ArtId);
		.wait(1000);
		giveMeMyName;
		lookupArtifact("marketPlace",MarketPlaceId);
		linkArtifacts(ArtId,"out-1", MarketPlaceId);
		jia.randInt(X,5);
		+patience(X+1);
		connect.

// subscribe as soon as possible
		
+!subscribe : not running(true)
	<- .wait(1000);
		!subscribe.
		
+!subscribe : running(true) & own(Portfolio,_,_,_) & manage(Asset)
	<- 	subscribeForAssetInformation("EURONEXT - EURONEXT PARIS",Asset);
		buy(Asset, 1, Portfolio, "MKT");
		-manage(Asset);
		!subscribe.
		
+!subscribe : running(true)
	<- 	!trade.
		
// Trade randomly		
+!trade : not running(true)
	<-	.wait(1000);
		!trade.

// Buy if possible and not done yet and i dont have any asset yet
+!trade : running(true) & myName(N)
	& indicators(_,Venue,Asset,_,_,_,Average,DlAverage,_,_)
	& not onMarket(_,N, _, Venue, "bid",Asset,_,_) // I am not yet a buyer
	& Asset \== "EURO"
	& own(Portfolio,_,"EURO",Amount) // I have enough money
	& not own(Portfolio,_,Asset,_) // I dont have this asset yet
	& Amount >= Average*1000
	& patience(Z)
	& coin(1)
	<-	Max=Amount/(Average*1000);
		jia.randInt(X,Max); // previously Max-1
		.random(Y); // return a random number between 0 and 1
		Price=DlAverage+Y*2-1;
		Q=X+1; // We avoid to send a "Buy 0" order
		.concat("I want to buy ", Q, " ", Asset, " for ", Price, " Euro each one", Phrase);
		.print(Phrase);
		.concat("LMT ",Price,OPT);
		-+countdown(Z);
		buy(Asset, Q, Portfolio, OPT); // Ajouter les parametres 
		.wait(2000);
		jia.randInt(F,2);
		-+coin(F);
		!trade.
		
// Sell if possible and not done yet
+!trade : running(true) & myName(N) 
	& indicators(_,Venue,Asset,_,_,_,Average,DlAverage,_,_)
	& not onMarket(_,N, _, Venue, "ask",Asset,_,_) // I am not yet a seller
	& own(Portfolio,_,Asset,Amount)	// I have some asset to sell 
	& Asset \== "EURO"
	& patience(Z)
	& coin(0)
	<-	jia.randInt(X,Amount);
		.random(Y);
		Price=DlAverage+Y*2-1;
		Q=X+1; // We avoid to send a "Sell 0" order
		.concat("I want to sell ", Q, " ", Asset, " for ", Price, " Euro each one", Phrase);
		.print(Phrase);
		.concat("LMT ",Price,OPT);
		sell(Asset, Q, Portfolio, OPT); // Ajouter les parametres 
		.wait(2000);
		-+countdown(Z);
		jia.randInt(F,2);
		-+coin(F);
		!trade.

+!trade : running(true) & myName(N)	& timeloop(T) & countdown(Z) & Z<=0 & onMarket(Date,N,Pf, Venue, Side, Asset, Qty, Price)
	<- 	cancelOrder(Date,Pf,Venue,Side,Asset,Qty,Price);
		.wait(T);
		!trade.
		
+!trade : running(true) & countdown(T)
	<-  .wait(2000);
		-+countdown(T-1);
		jia.randInt(F,2);
		-+coin(F);
		!trade.
		
