/**
 * 
 */
package marketSim.controller;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Date;

import marketSim.model.AbstractAsset;
import marketSim.model.MarketSimModel;

/**
 * @author Nicolas
 *
 */
public class StatisticsOutputByPortfolio {
	protected Date date=null;
	int idOfData=0;
	String namePortfolio;
	
	protected PrintWriter dataFile=null;
	protected PrintWriter dataDaysFile=null;
	
	protected ArrayList<String> assets = new ArrayList<String>();
	protected ArrayList<Integer> quantities = new ArrayList<Integer>();
	protected ArrayList<Float> values = new ArrayList<Float>();
	
	public StatisticsOutputByPortfolio(String namePortfolio, MarketSimModel model)
	{
		this.namePortfolio=namePortfolio;
		try {
			dataFile=new PrintWriter("./out/data/" + namePortfolio,"UTF-8");
			dataDaysFile=new PrintWriter("./out/data/days" + namePortfolio,"UTF-8");
		} catch (FileNotFoundException | UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		dataFile.println("# Data generated by the simulator to show evolution of portfolio '" + namePortfolio + "'");
		dataFile.println("# This file give the number of assets and the total value of these assets in the portfolio for each one");
		dataFile.print("id date");
		for(int i = 0; i<model.getAssets().size(); i++)
		{
			dataFile.print("\t" + model.getAssets().get(i).getName().replace(" ", "") + "\t" + model.getAssets().get(i).getName().replace(" ", ""));
			assets.add(model.getAssets().get(i).getName());
			quantities.add(0);
			values.add((float) 0.0);
		}
		dataFile.println("");
		dataFile.flush();
	}
	
	public void putData(Date date)
	{
		idOfData++;
		this.date=date;
	}
	
	public void putData(AbstractAsset asset, int quantity, float value)
	{
		int i=assets.indexOf(asset.getName());
		quantities.set(i, quantity);
		values.set(i, value);
	}
	
	public void print()
	{
		dataFile.print(idOfData + " " + date.getDate() + "/" + (date.getMonth()+1) + "/" + (date.getYear()+1900));
		for(int i = 0; i<assets.size(); i++)
		{
			dataFile.print("\t" + quantities.get(i) + "\t" + values.get(i));
		}
		dataFile.println("");
		dataFile.flush();
		for(int i = 0; i<assets.size(); i++)
		{
			quantities.set(i,0);
			values.set(i,(float) 0.0);
		}
	}
}
